// score:100
#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

template<typename S>
void xmin(S&a, S const&b){
    a = min(a, b);
}

int n;

constexpr ll inf = 1e18;


vector<vector<ll> > calc_dist(vector<vector<pair<int, int> > > const&g){
    vector<vector<ll> > ret(n, vector<ll>(n, inf));
    stack<int> s;
    for(int i=0;i<n;++i){
        s.emplace(i);
    }
    while(!s.empty()){
        int u=s.top(); s.pop();
        if(u<0){
            u=-1-u;
            for(auto &e:g[u]){
                for(int i=0;i<n;++i){
                    xmin(ret[u][i], ret[e.first][i]+e.second);
                }
            }
        } else {
            if(ret[u][u] == inf){
                ret[u][u] = 0;
                s.emplace(-1-u);
                for(auto &e:g[u]){
                    s.emplace(e.first);
                }
            }
        }
    }
    return ret;
}

struct Cand{
    int u, v;
    ll d_cable, d_slope;
    // check if *this is worse that o
    bool operator<(Cand const&o) const {
        return d_cable*o.d_slope > d_slope*o.d_cable;
    }
    bool valid() const {
        return u!=v && abs(d_cable) < inf/2 && abs(d_slope) < inf/2;
    }
};

signed main(){
    cin.exceptions(ios::failbit | ios::badbit | ios::eofbit);
    cin.tie(0); ios_base::sync_with_stdio(false);

    array<int, 2> m;
    cin >> n >> m[0] >> m[1];

    array<vector<vector<pair<int, int> > >, 2> gs;
    for(auto &e:gs) e.resize(n);
    array<vector<vector<ll> >, 2> dists;

    for(int it=0;it<2;++it){
        for(int i=0;i<m[it];++i){
            int a, b, w;
            cin >> a >> b >> w;
            gs[it][a].emplace_back(b, it==0 ? w : -w);
        }
        dists[it] = calc_dist(gs[it]);
    }
    vector<Cand> cands;

    for(int i=0;i<n;++i){
        for(int j=0;j<n;++j) if(j!=i){
            Cand c{i, j, dists[0][i][j], -dists[1][j][i]};
            if(c.valid()){
                if(!cands.empty() && cands[0] < c){
                    cands.clear();
                }
                if(cands.empty() || !(c < cands[0])){
                    cands.push_back(c);
                }
            }
        }
    }
    if(cands.empty()){
        cout << "None\n";
    } else {
        auto const&e = cands.back();
        cout << e.u << " " << e.v << " " << e.d_cable << " " << e.d_slope << "\n";
    }

}
