// score:100
#include<iostream>
#include<vector>
#include<functional>

# define inf (1e9)
using namespace std;

int N, K, M;

void calculate(int start, const vector<vector<pair<int,int> > >& E, vector<int>& result, std::function<int(int,int)> fun) {
  result[start] = 0;
  vector<int> C(N, 0);
  for(int u=0; u<N; ++u) {
    for(pair<int,int> e: E[u]) {
      C[e.first]++;
    }
  }

  vector<int> Q;
  for(int u=0; u<N; ++u) {
    if (C[u] == 0) Q.push_back(u);
  }

  for (int q=0; q<N; ++q) {
    for (pair<int,int> e: E[Q[q]]) {
      result[e.first] = fun(result[e.first], result[Q[q]] + e.second);
      --C[e.first];
      if (C[e.first] == 0) Q.push_back(e.first);
    }
  }
}


int main(void) {
  int a, b, c;
  cin >> N >> K >> M;
  vector<vector<vector<pair<int, int> > > > edges(2, vector<vector<pair<int,int> > >(N));

  for(int i=0; i<K; ++i) {
    cin >> a >> b >> c;
    //--a; --b;
    edges[0][a].push_back(make_pair(b,c));
  }
  for(int i=0; i<M; ++i) {
    cin >> a >> b >> c;
    //--a; --b;
    edges[1][b].push_back(make_pair(a,c));
  }

  int best_p = -1, best_q = -1, best_ts = 1, best_tc = inf;
  for(int p=0; p<N; ++p) {
    vector<int> slopes(N, -inf), cablecars(N, inf);
    calculate(p, edges[0], cablecars, [](int a, int b) { return min(a,b); });
    calculate(p, edges[1], slopes, [](int a, int b) { return max(a,b); });
    for(int q=0; q<N; ++q) {
      if (p==q) continue;
	  if (cablecars[q] == inf || slopes[q] == inf) continue;
      if ((long long)cablecars[q] * (long long)best_ts < (long long)slopes[q] * (long long)best_tc) {
        best_p = p;
        best_q = q;
        best_ts = slopes[q];
        best_tc = cablecars[q];
      }
    }
  }
  if (best_p == -1 || best_q == -1) cout << "None" << endl;
  else cout << best_p/*+1*/ << " " << best_q/*+1*/ << " " << best_tc << " " << best_ts << endl;
  return 0;
}
