// score:100
// O(T^2*k^2 + n) where T is the max. tastiness of a length-1-stollen.
// Not sure if this is meant to get 100

#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

template<typename T>
void xmin(T&a, T const&b){
    a = min(a, b);
}

template<typename T>
void xmax(T&a, T const&b){
    a = max(a, b);
}


constexpr ll inf = 1e18;

signed main(){
	cin.tie(0); ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    ++k;
    vector<int> v(n);
    for(auto &e:v) cin >> e;
    vector<ll> pre(n+1, 0);
    for(int i=0;i<n;++i){
        pre[i+1] = pre[i] + v[i];
    }
    pre.emplace_back(inf);
    auto next_non_smaller = [&](ll x){
        return lower_bound(pre.begin(), pre.end(), x) - pre.begin();
    };
    vector<vector<int> > vis(k+1, vector<int>(n+1));
    int tim = 0;
    vector<pair<int, int> > q;
    // something similar to a depth-limited dfs
    // will reach at most O((R-L) * k^2) states
    auto can = [&](int L, int R){
        ++tim;
        q.clear();
        auto enqueue = [&](int x, int s){
            if(vis[s][x] != tim){
                q.emplace_back(x, s);
                vis[s][x] = tim;
            }
        };
        enqueue(0, 0);
        for(size_t it=0;it<q.size();++it){
            int u, s;
            tie(u, s) = q[it];
            if(s == k) continue;
            int v = next_non_smaller(pre[u] + L);
            while(pre[v] - pre[u] <= R){
                enqueue(v, s+1);
                ++v;
            }
        }
        if(vis[k][n] == tim){
            return true;
        }
        return false;
    };
    ll ans = 2* *max_element(v.begin(), v.end());
    // Optimal [L, R] lies inside a 4T x 4T square, so we can 2-pointer walk.
    // might need -2*(max_element) actually
    ll L = max<ll>(0, pre[n] / k - (n==0 ? 0 : *max_element(v.begin(), v.end()))), R = L;
    while(k*L <= pre[n]){
        if(can(L, R)){
            ans = min(ans, R-L);
            ++L;
        } else if(R > L+ans){
            ++L;
        } else {
            ++R;
        }
    }
    cout << ans << "\n";
}
