#include <bits/stdc++.h> // score: 100
using namespace std;

vector<string> words;
string s;
bool compute_match(size_t i, size_t j) {
  return strncmp(s.data()+i, words[j].data(), words[j].size()) == 0;
}

const uint8_t impossible = numeric_limits<uint8_t>::max();
const uint8_t ambiguous = numeric_limits<uint8_t>::max()-1;
const uint8_t unique_eof = numeric_limits<uint8_t>::max()-2;
bool is_unique(uint8_t x) { return x<ambiguous; }
uint8_t replace_if_unique(uint8_t x, uint8_t newval) {
  return is_unique(x) ? newval : x;
}
uint8_t combine(uint8_t x, uint8_t y) {
  if (x == impossible) return y;
  if (y == impossible) return x;
  return ambiguous;
}

int main() {
  size_t n, m, k; cin >> n >> m >> k;
  cin >> s;
  copy_n(istream_iterator<string>(cin), k, back_inserter(words));
  vector<int> ans;
  vector<vector<size_t>> match(s.size()+1);
  for (size_t i=0; i<=s.size(); ++i)
    for (size_t j=0; j<words.size(); ++j)
      if (i >= words[j].size() && compute_match(i - words[j].size(), j))
        match[i].push_back(j);

  vector dp(m+1, vector<uint8_t>(n+1, impossible));
  dp[0][0] = unique_eof;
  for (size_t i=1; i<=m; ++i)
    for (size_t j=1; j<=n; ++j)
      dp[i][j] = accumulate(match[i].begin(), match[i].end(), impossible,
                            [&](uint8_t a, size_t k) {
                              return combine(a, replace_if_unique(dp[i - words[k].size()][j-1], k));
                            });

  auto x = dp[m][n];
  if (x == impossible) {
    cout << "not decodable\n";
  } else if (is_unique(x)) {
    string t;
    while (x != unique_eof) {
      t.push_back(x+'A');
      --n;
      m -= words[x].size();
      x = dp[m][n];
    }
    reverse(t.begin(), t.end());
    cout << t << '\n';
  } else {
    cout << "not uniquely decodable\n";
  }
}
