#include <bits/stdc++.h> // score: 100
using namespace std;

vector<string> words;
string s;
vector<vector<uint8_t>> match;
bool compute_match(size_t i, size_t j) {
  return strncmp(s.data()+i, words[j].data(), words[j].size()) == 0;
}

const uint8_t impossible = numeric_limits<uint8_t>::max();
const uint8_t ambiguous = numeric_limits<uint8_t>::max()-1;
const uint8_t unique_eof = numeric_limits<uint8_t>::max()-2;
bool is_unique(uint8_t x) { return x<ambiguous; }

map<pair<int32_t, int8_t>, uint8_t> memo;
uint8_t backtrack(size_t i, size_t word_cnt) {
  if (word_cnt==0 && i==0) return unique_eof;
  if (word_cnt==0 || i==0) return impossible;

  auto it = memo.find({i, word_cnt});
  if (it != memo.end()) return it->second;

  uint8_t& answer = memo[{i, word_cnt}];
  answer = impossible;
  for (size_t j : match[i]) {
    auto x = backtrack(i - words[j].size(), word_cnt-1);
    if (x == impossible) continue;
    if (answer == impossible)
      answer = is_unique(x) ? j : ambiguous;
    else
      return answer = ambiguous;
  }
  return answer;
}

int main() {
  size_t n, m, k; cin >> n >> m >> k;
  cin >> s;
  copy_n(istream_iterator<string>(cin), k, back_inserter(words));
  vector<int> ans;
  match.resize(s.size()+1);
  for (size_t i=0; i<=s.size(); ++i)
    for (size_t j=0; j<words.size(); ++j)
      if (i >= words[j].size() && compute_match(i - words[j].size(), j))
        match[i].push_back(j);
  auto x = backtrack(m, n);
  if (x == impossible) {
    cout << "not decodable\n";
  } else if (is_unique(x)) {
    string t;
    while (x != unique_eof) {
      t.push_back(x+'A');
      --n;
      m -= words[x].size();
      x = backtrack(m, n);
    }
    reverse(t.begin(), t.end());
    cout << t << '\n';
  } else {
    cout << "not uniquely decodable\n";
  }
}
